import { CollectionOf, Description, Property, Schema } from '@tsed/schema'

@Schema({ title: 'FlexPDF Conversion' })
export class FlexpdfConversionEntity {
  @CollectionOf(String)
  @Description('Converted Page Hashes')
  converted: string[]

  @Property()
  @Description('Credits needed for Conversion')
  conversionCredits: number

  @Property()
  @Description('Currently available user credit')
  availableCredits: number

  @Property()
  @Description('Total credits spent by user')
  totalCreditsSpent: number
}
