import { CollectionOf, Description, Property, Schema } from '@tsed/schema'

@Schema({ title: 'FlexPDF Preflight' })
export class FlexpdfPreflightEntity {
  @CollectionOf(String)
  @Description('Unconverted Page Hashes')
  unconverted: string[]

  @Property()
  @Description('Credits needed for Conversion')
  conversionCredits: number

  @Property()
  @Description('Currently available user credit')
  availableCredits: number
}
