import { Description, Example, Property, Schema } from '@tsed/schema'
import { Entity } from '../lib/Entity'

@Schema({ title: 'Push Subscription' })
export class PushSubscriptionEntity extends Entity {
  @Property()
  @Description('Unique ID')
  @Example(1)
  id: number

  @Property()
  @Description('PWA ID')
  @Example(1)
  pwaId: number

  @Property()
  @Description('reader ID')
  @Example(1)
  readerId: number

  @Property()
  @Description('Endpoint')
  @Example('https://fcm.googleapis.com/fcm/send/...')
  endpoint: string

  @Property()
  @Description('Public Key')
  @Example('BDgK....BWx4')
  publicKey: string

  @Property()
  @Description('Secret')
  @Example('TDAp....YG5Q')
  secret: string

  @Property()
  @Description('Created at')
  createdAt: Date

  @Property()
  @Description('Updated at')
  updatedAt: Date
}
