import { BaseModel } from '@magloft/db-client/lib/models/base/Model.base'
import { Description, Example, Property, Schema } from '@tsed/schema'
import { Entity } from '../lib/Entity'

@Schema({ title: 'Reader Subscription' })
export class ReaderSubscriptionEntity extends Entity {
  constructor(model?: BaseModel, attributes?: object) {
    super(model, attributes)
    if (this.startDate) { this.startDate = new Date(this.startDate) }
    if (this.endDate) { this.endDate = new Date(this.endDate) }
  }

  @Property()
  @Description('Unique ID')
  @Example(1)
  id: number

  @Property()
  @Description('Order ID')
  @Example('110000083339876')
  orderId: string

  @Property()
  @Description('Source')
  @Example('custom')
  source: string

  @Property()
  @Description('User ID')
  @Example('930E656C-F72A-428A-AEFA-FB6552240D9C')
  userId: string

  @Property()
  @Description('Publication ID')
  @Example(1)
  publicationId: number

  @Property()
  @Description('Reader ID')
  @Example(1)
  readerId: number

  @Property()
  @Description('Active')
  @Example('Active')
  active: boolean

  @Property()
  @Description('Start Date')
  startDate: Date

  @Property()
  @Description('End Date')
  endDate: Date
}
