import { Description, Example, Property, Schema } from '@tsed/schema'
import { Entity } from '../lib/Entity'

export type RestHookEvent = 'reader:signup' | 'reader:signin' | 'reader:signout' | 'reader:signup'

@Schema({ title: 'Rest Hook' })
export class RestHookEntity extends Entity {
  @Property() @Description('Unique ID') @Example(1) id: number
  @Property() @Description('Publication ID') @Example(102) publicationId: number
  @Property() @Description('Event') @Example('reader:signup') event: RestHookEvent
  @Property() @Description('Target URL') @Example('https://hooks.website.com/1234') targetUrl: string
}
