import { Description, Example, Property, Schema } from '@tsed/schema'
import { IntercomUserEntity } from './IntercomUserEntity'
import { UserEntity } from './UserEntity'

@Schema({ title: 'Session' })
export class SessionEntity {
  @Property()
  @Description('Authenticated')
  @Example(true)
  authenticated: boolean

  @Property()
  @Description('User')
  user?: UserEntity

  @Property()
  @Description('User Intercom Details')
  intercomUser?: IntercomUserEntity

  @Property()
  @Description('JWT Token')
  @Example('eyJhbGc...BoXFk')
  token?: string
}
