import { ArgsType, Field, Int } from 'type-graphql'

@ArgsType()
export class GetByIdArgs {
  @Field(type => Int) id: number
}

@ArgsType()
export class GetBySlugArgs {
  @Field() slug: string
}

@ArgsType()
export class GetListArgs {
  // Publication Id
  @Field(type => Int) publicationId: number
  // Cursor
  @Field(type => Int, { defaultValue: 0 }) offset: number
  @Field(type => Int, { defaultValue: 12 }) limit: number
  // Order
  @Field({ defaultValue: 'date' }) orderBy: string
  @Field({ defaultValue: 'desc' }) orderDir: string
  // Filter
  @Field(type => [Int], { nullable: true }) ids?: number[]
  @Field({ nullable: true }) source?: string
  @Field({ nullable: true }) unlockType?: string
  @Field(type => Int, { nullable: true }) categoryId?: number
  @Field(type => [Int], { nullable: true }) categoryIds?: number[]
  @Field({ nullable: true }) searchText?: string
}
