import * as db from '@magloft/db-client'
import { Field, Int, ObjectType } from 'type-graphql'
import { BaseSchema } from '../../lib/graphql/BaseSchema'

@ObjectType()
export class Category extends BaseSchema<db.Category> {
  @Field(type => Int) public id: number
  @Field({ nullable: true }) public slug?: string
  @Field({ nullable: true }) public icon?: string
  @Field({ nullable: true }) public description?: string
  @Field({ nullable: true }) public image?: string
  @Field() public color: string
  @Field() public title: string
  @Field(type => Int) public position: number
}
