import { ResolverService } from '@tsed/graphql'
import { Args, Ctx, Query } from 'type-graphql'
import { Category } from './Category'
import { CategoryDataSource } from './CategoryDataSource'
import { GetByIdArgs, GetBySlugArgs } from './CategoryInput'

interface DataSources {
  categoryDataSource: CategoryDataSource
}

@ResolverService(Category)
export class PwaResolver {
  @Query(() => Category)
  public async categoryGetById(@Ctx('dataSources') { categoryDataSource }: DataSources, @Args() args: GetByIdArgs): Promise<Category> {
    return categoryDataSource.getById(args)
  }

  @Query(() => Category)
  public async categoryGetBySlug(@Ctx('dataSources') { categoryDataSource }: DataSources, @Args() args: GetBySlugArgs): Promise<Category> {
    return categoryDataSource.getBySlug(args)
  }
}
