import { ApolloServerPlugin } from 'apollo-server-plugin-base'
import { FieldNode } from 'graphql'

export const GraphQLQueryContextPlugin: ApolloServerPlugin = {
  requestDidStart({ request }) {
    if (request.operationName === 'IntrospectionQuery') { return }
    return {
      didResolveOperation({ operation, context }) {
        if (operation.kind !== 'OperationDefinition' || !['query', 'mutation'].includes(operation.operation)) { return }
        const [selection] = operation.selectionSet.selections as FieldNode[]
        context.queryName = selection.name.value
        context.queryFields = selection.selectionSet.selections.map(({ name }: FieldNode) => name.value)
      }
    }
  }
}
