import { ResolverService } from '@tsed/graphql'
import { Args, Ctx, Mutation } from 'type-graphql'
import { BillingPortal, Checkout } from './Purchase'
import { PurchaseDataSource } from './PurchaseDataSource'
import { CreateBillingPortalSessionArgs, CreateCheckoutSessionArgs } from './PurchaseInput'

interface DataSources {
  purchaseDataSource: PurchaseDataSource
}

@ResolverService()
export class PurchaseResolver {

  @Mutation(() => Checkout)
  public async purchaseCreateCheckoutSession(@Ctx('dataSources') { purchaseDataSource }: DataSources, @Args() args: CreateCheckoutSessionArgs): Promise<Checkout> {
    return purchaseDataSource.createCheckoutSession(args)
  }

  @Mutation(() => BillingPortal)
  public async purchaseCreateBillingPortalSession(@Ctx('dataSources') { purchaseDataSource }: DataSources, @Args() args: CreateBillingPortalSessionArgs): Promise<BillingPortal> {
    return purchaseDataSource.createBillingPortalSession(args)
  }
}
