import { ResolverService } from '@tsed/graphql'
import { Arg, Ctx, Int, Query } from 'type-graphql'
import { Pwa } from './Pwa'
import { PwaDataSource } from './PwaDataSource'

interface DataSources {
  pwaDataSource: PwaDataSource
}

@ResolverService(Pwa)
export class PwaResolver {
  @Query(() => Pwa)
  public async pwaGetById(@Ctx('dataSources') { pwaDataSource }: DataSources, @Arg('id', () => Int) id: number): Promise<Pwa> {
    return pwaDataSource.getById(id)
  }

  @Query(() => Pwa)
  public async pwaGetByDomain(@Ctx('dataSources') { pwaDataSource }: DataSources, @Arg('domain', () => String) domain: string): Promise<Pwa> {
    return pwaDataSource.getByDomain(domain)
  }
}
