import * as db from '@magloft/db-client'
import { Field, Int, ObjectType } from 'type-graphql'
import { BaseSchema } from '../../lib/graphql/BaseSchema'

@ObjectType()
export class User extends BaseSchema<db.User> {
  @Field(type => Int) public id: number
  @Field() public email: string
  @Field({ nullable: true }) public firstname?: string
  @Field({ nullable: true }) public lastname?: string
  @Field({ nullable: true }) public token?: string

  constructor(user: db.User, token?: string) {
    super(user)
    if (token) { this.token = token }
  }
}
