import { IsEmail, MinLength } from 'class-validator'
import { ArgsType, Field } from 'type-graphql'

@ArgsType()
export class GetByTokenArgs {
  @Field() token: string
}

@ArgsType()
export class SignInArgs {
  @Field() @IsEmail() email: string
  @Field() @MinLength(6) password: string
}

@ArgsType()
export class SignOutArgs {
  @Field() token: string
}
