import * as kms from '@magloft/kms'
import { $log, Configuration } from '@tsed/common'
import { PlatformExpress } from '@tsed/platform-express'
import { Server } from './server'

export async function main() {
  const config = await kms.config<Partial<Configuration>>('credentials/services/magloft-api')
  const server = await PlatformExpress.bootstrap(Server, config)
  await server.listen()
}

main().catch((error: Error) => {
  $log.error(error)
})
