import { BaseModel } from '@magloft/db-client/lib/models/base/Model.base'

interface EntityConstructor<M> {
  new(model: BaseModel, attributes?: object): M
}

export class Entity {
  static from<T extends Entity>(this: EntityConstructor<T>, model: BaseModel, attributes?: object): T {
    return new this(model, attributes)
  }

  static map<T extends Entity>(this: EntityConstructor<T>, models: BaseModel[], attributes?: object): T[] {
    return models.map(model => new this(model, attributes))
  }

  constructor(public model: BaseModel | object = {}, attributes?: object) {
    const data = model instanceof BaseModel ? model.get() : {}
    Object.assign(this, data, attributes)
  }
}
