import { CollectionOf, Description, Example, Property, Schema } from '@tsed/schema'
import { Entity } from './Entity'

@Schema({ title: 'ListEntity' })
export class ListEntity<T> {
  @Property()
  @Description('Total')
  @Example(1000)
  total: number

  @Property()
  @Description('Limit')
  @Example(100)
  limit: number

  @Property()
  @Description('Offset')
  @Example(0)
  offset: number

  @CollectionOf(Entity)
  @Description('Records')
  @Example([])
  records: T[]
}

