const SEARCH_REGEX = /(\w|\s|,|'|`)/

export function searchMatch(input: string, searchTerms: string[]) {
  const text = input.toLowerCase()
  const indices = searchTerms.map((searchTerm) => text.indexOf(searchTerm)).filter((index) => index !== -1)
  let start = indices.reduce((cur, index) => cur < index ? cur : index, text.length)
  for (let i = start - 1; i >= 0; i -= 1) {
    if (SEARCH_REGEX.test(text[i])) {
      start = i
    } else {
      i = 0
    }
  }
  let end = indices.reduce((cur, index) => cur > index ? cur : index, 0)
  for (let i = end + 1; i < text.length; i += 1) {
    if (SEARCH_REGEX.test(text[i])) {
      end = i
    } else {
      i = text.length
    }
  }
  let match = input.substring(start, end + 1).trim()
  match = match.replace(/^\.\s?/, '')
  if (match.length > 150) { match = match.substring(0, 150) + '...' }
  return match
}
