import { JsonMapper, JsonMapperCtx, JsonMapperMethods } from '@tsed/json-mapper'

@JsonMapper(Date)
export class DateMapper implements JsonMapperMethods {
  deserialize(data: string | number | Date, options: JsonMapperCtx): Date {
    if (data instanceof Date) { return data }
    if (typeof data === 'string') { return new Date(data) }
    if (typeof data === 'number') { return new Date(data * 1000) }
    return null
  }

  serialize(object: Date, options: JsonMapperCtx): number {
    return object ? Math.floor(object.getTime() / 1000) : 0
  }
}
