import { IMiddleware, Inject, Middleware, Next, PlatformApplication, Req, Res, Response } from '@tsed/common'
import { AuthMiddleware, AuthRequest } from './AuthMiddleware'

@Middleware()
export class GraphQLAuthMiddleware implements IMiddleware {
  @Inject() authMiddleware: AuthMiddleware
  @Inject() app: PlatformApplication

  use(@Req() request: AuthRequest, @Res() _: Response, @Next() next: Next) {
    const { query, headers, cookies } = request
    const queryToken = query.token as string
    const headerToken = headers['x-magloft-token'] as string
    const legacyHeaderToken = headers['x-magloft-accesstoken'] as string
    return this.authMiddleware.use(() => { next() }, request, queryToken, headerToken, legacyHeaderToken, cookies)
  }
}
