import { connect } from '@magloft/db-client'
import * as kms from '@magloft/kms'
import { fixArticleInfo } from './migrations/fix-article-info'
import { generateText } from './migrations/generate-text'

async function main() {
  const db = connect(kms.config('credentials/db/cloud-server'))
  await generateText(db, { publicationId: 12210 })
  await fixArticleInfo(db, { publicationId: 12210 })
  await db.close()
}

main().catch(console.error)
