import { RestHook } from '@magloft/db-client'
import { ConverterService } from '@tsed/common'
import { Injectable } from '@tsed/di'
import fetch from 'node-fetch'

@Injectable()
export class RestHookService {
  constructor(private converter: ConverterService) { }

  notify<T>(restHooks: RestHook[], entity: T): void {
    const data = this.converter.serialize(entity, { withIgnoredProps: false })
    const payload = Object.entries(data).reduce<unknown>((obj, [key, value]) => {
      if (value !== undefined) { obj[key] = value }
      return obj
    }, {})
    const body = JSON.stringify(payload)
    const headers = { 'Accept': 'application/json', 'Content-Type': 'application/json' }
    Promise.all(restHooks.map(({ targetUrl }) => fetch(targetUrl, { method: 'POST', headers, body }))).catch(() => { })
  }
}
