import * as SuperTest from 'supertest'
import { BootstrapModule } from '../helpers'

export interface RequestModuleContext {
  request: SuperTest.SuperAgentTest
  login: (email: string, password: string) => Promise<void>
}

export const RequestModule: BootstrapModule<RequestModuleContext> = {
  config: async () => { },
  context: async (test) => {
    const request = SuperTest.agent(test.callback())
    const login = async (email: string, password: string) => {
      const { header, body } = await request.post('/portal/users/session').send({ email, password }).withCredentials().expect(200)
      request.set('Cookie', header['set-cookie'])
      request.set('x-magloft-token', body.token)
    }
    return { request, login }
  }
}
